' //////////////////////////////////////////////////////////////////////
' Sound Demo
' AUTHOR: Nick Sabalausky
' LAST MODIFIED: 2.2.06
' VERSION 1.0
'
' Demonstration of NS_sound_drv.
' 
' Makes a slowly sweeping sine wave
'
' Note: This has no video output, so make sure you either hook up 
'       the Hydra's audio to a stereo or speaker, or feed your TV
'       a valid video signal from a VCR/DVD/game system/etc.
'       Otherwise, your TV might not play the audio.
'
' //////////////////////////////////////////////////////////////////////

'///////////////////////////////////////////////////////////////////////
' CONSTANTS ////////////////////////////////////////////////////////////
'///////////////////////////////////////////////////////////////////////
CON
  _clkmode = xtal2 + pll8x            ' enable external clock and pll times 8
  _xinfreq = 10_000_000 + 5000        ' set frequency to 10 MHZ plus some error for xtals that are not exact add 1000-5000 usually works
  _stack = (128) >> 2                 ' accomodate stack   

  FREQ_START = 500
  FREQ_DELTA_START = -1
  FREQ_MAX = 800
  FREQ_MIN = 200

'///////////////////////////////////////////////////////////////////////
' VARIABLES ////////////////////////////////////////////////////////////
'///////////////////////////////////////////////////////////////////////
VAR

  long freq, freq_delta

'///////////////////////////////////////////////////////////////////////
' OBJECTS //////////////////////////////////////////////////////////////
'///////////////////////////////////////////////////////////////////////
OBJ

  snd : "NS_sound_drv_010.spin"   'Sound Driver

'///////////////////////////////////////////////////////////////////////
' FUNCTIONS ////////////////////////////////////////////////////////////
'///////////////////////////////////////////////////////////////////////

'// PUB start //////////////////////////////////////////////////////////
PUB start

  snd.start

  freq := FREQ_START
  freq_delta := FREQ_DELTA_START

  repeat
    snd.set_freq(freq)

    freq += freq_delta
    if((freq => FREQ_MAX) or (freq =< FREQ_MIN))
      -freq_delta

    WAITCNT(CNT + CONSTANT(80_000_000/100))


'///////////////////////////////////////////////////////////////////////
' DATA /////////////////////////////////////////////////////////////////
'///////////////////////////////////////////////////////////////////////

DAT

